Index: XIOS/dev/branch_openmp/Note/rapport ESIWACE.tex.backup
===================================================================
--- XIOS/dev/branch_openmp/Note/rapport ESIWACE.tex.backup	(revision 1548)
+++ XIOS/dev/branch_openmp/Note/rapport ESIWACE.tex.backup	(revision 1552)
@@ -5,8 +5,9 @@
 \usepackage[usenames,dvipsnames,svgnames,table]{xcolor}
 \usepackage{amsmath}
+\usepackage{url}
 
 % Title Page
 
-\title{Developping XIOS with multithread : to accelerate the IO of climate models}
+\title{Developing XIOS with multi-thread : to accelerate the I/O of climate models}
 
 \author{}
@@ -16,91 +17,191 @@
 \maketitle
 
-\section{background}
+\section{Context}
 
 The simulation models of climate systems, running on a large number of computing resources can produce an important volume of data. At this 
-scale, the IO and the post-treatement of data becomes a bottle-neck for the performance. In order to manage efficiently the data flux 
-generated by the simulations, we use XIOS developped by the Institut Pierre Simon Laplace and Maison de la simulation.
-
-XIOS, a libarary dedicated to intense calculates, allows us to easily and efficiently manage the parallel IO on the storage systems. XIOS 
+scale, the I/O and the post-treatment of data becomes a bottle-neck for the performance. In order to manage efficiently the data flux 
+generated by the simulations, we use XIOS developed by the Institut Pierre Simon Laplace and Maison de la simulation.
+
+XIOS, a library dedicated to intense calculates, allows us to easily and efficiently manage the parallel I/O on the storage systems. XIOS 
 uses the client/server scheme in which computing resources (server) are reserved exclusively for IO in order to minimize their impact on 
-the performance of the climate models (client).
-
-Cette bibliothÃšque, dÃ©diÃ©e au calcul intensif, permet de gÃ©rer efficacement et simplement les
-entrÃ©e/sortie parallÃšles des donnÃ©es sur les systÃšmes de stockage. Dans cette nouvelle
-approche, orientÃ©e client/serveur, des cÅurs de calcul sont exclusivement dÃ©diÃ©s aux I/O de
-faÃ§on Ã  minimiser leur impact sur le temps de calcul des modÃšles. Lâutilisation des
-communications asynchrones entre les modÃšles (clients) et les serveurs I/O permet de lisser
-les pics I/O en envoyant un flux de donnÃ©es constant au systÃšme de fichiers tout au long de la
-simulation, recouvrant ainsi totalement les Ã©critures par du calcul.
-
-
-The aim of this project ESIWACE is to develop a multithreaded version of XIOS, a library dedicated to IO manegement of climate code.
-The current XIOS code lies on a single level of parallelization using MPI. However, many climate models are now disigned with two-level 
-parallelization through MPI and OpenMP. The difference of parallelization between the climate models and XIOS can lead to performance lost 
-because XIOS can not cope with threads. This fact 
-
-
-The resulting multithreaded XIOS is desinged to cope with climate models which use a two-level parallelization (MPI/Openmp) scheme.
-The principle model we work with is the LMDZ code developped at Laboratoire de MÃ©tÃ©orologie Dynamique. This model has 
-
-
-
-\section{Developpement of a thread-friendly MPI for XIOS}
-
-XIOS is a library dedicated to IO management of climate code. It has a client-server pattern in which clients are in charge of computations 
-and servers manage the reading and writing of files. The communication between clients and servers are handled by MPI.
-However, some of the climate models (\textit{e.g.} LMDZ) nowadays use an hybrid programming policy. Within a shared memory node, OpenMP 
-directives are used to manage message exchanges. In such configuration, XIOS can not take full advantages of the computing resources to 
-maximize the performance. This is because XIOS can only work with MPI processes. Before each call of XIOS routines, threads of one MPI 
-process must gather their information to the master thread who works as an MPI process. After the call, the master thread distributes the 
-updated information among its slave threads. As result, all slave threads have to wait while the master thread calls the XIOS routines. 
-This introduce extra synchronization into the model and leads to not optimized performance. Aware of this situation, we need to develop a 
-new version of XIOS (EP\_XIOS) which can work with threads, or in other words, can consider threads as they were processes. To do so, we 
-introduce the MPI endpoints.  
-
-
-The MPI endpoints (EP) is a layer on top of an existing MPI Implementation. All MPI function, or in our work the functions used in XIOS, 
-will be reimplemented in order to cope with OpenMP threads. The idea is that, in the MPI endpoints environment, each OpenMP thread will be 
-associated with a unique rank and with an endpoint communicator. This rank (EP rank) will replace the role of the classic MPI rank and will 
-be used in MPI communications. In order to successfully execute an MPI communication, for example \verb|MPI_Send|, we know already which 
-endpoints to be the receiver but not sufficient. We also need to know which MPI process should be involved in such communication. To 
-identify the MPI rank, we added a ``map'' in the EP communicator in which the relation of all EP and MPI ranks can be easily obtained.
-
-
-In XIOS, we used the ``probe'' technique to search for arrived messages and then performing the receive action. The principle is 
-that sender processes execute the send operations as usual. However, to minimise the time spent on waiting incoming messages, the receiver 
-processe performs in the first place the \verb|MPI_Probe| function to check if a message destinated to it has been published. If yes, the 
-process execute in the second place the \verb|MPI_Recv| to receive the message. In this situation, if we introduce the threads, problems 
-occur. The reason why the ``probe'' method is not suitable is that messages destinated to one certain process can be probed by any of 
-its threads. Thus the message can be received by the wrong thread which gives errors.
-
-To solve this problem, we introduce the ``matching-probe'' technique. The idea of the method is that each process is equiped with a local 
-incoming message queue. All incoming message will be probed, sorted, and then stored in this queue according to their destination rank. 
-Every time we call an MPI function, we firstly call the \verb|MPI_Mprobe| function to get the handle to 
-the incoming message. Then, we identify the destination thread rank and store the message handle inside the local queue of the target 
-thread. After this, we perform the usual ``probe'' technique upon the local incoming message queue. In this way, we can assure the messages 
-to be received by the right thread.
-
-Another issue remains in this technique: how to identify the receiver's rank? The solution is to use the tag argument. In the MPI 
-environment, a tag is an integer ranging from 0 to $2^{31}$. We can explore the large range of the tag to store in it information about the 
-source and destination thread ranks. We choose to limite the first 15 bits for the tag used in the classic MPI communication, the next 8 
-bits to the sender's thread rank, and the last 8 bits to the receiver's thread rank. In such way, with an extra analysis of the EP tag, we 
-can identify the ranks of the sender and the receiver in any P2P communication. As results, we a thread probes a message, it knows 
-exactly in which local queue should store the probed message. 
-
-
-With the global rank map, tag extension, and the matching-probe techniques, we are able to use any P2P communication in the endpoint 
-environment. For the collective communications, we perform a step-by-step execution and no special technique is required. The most 
-representative functions is the collective communications are \verb|MPI_Gather| and \verb|MPI_Bcast|. A step-by-step execution consists of 
-3 steps (not necessarily in this order): arrangement of the source data, execution of the MPI function by all 
-master/root threads, distribution or arrangement of the data among threads. 
-
-For example, if we want to perform a broadcast operation, 2 steps are needed. Firstly, the root thread, along with the master threads of 
-other processes, perform the classic \verb|MPI_Bcast| operation. Secondly, the root thread, and the master threads send data to threads 
-sharing the same process via local memory transfer. In another example for illustrating the \verb|MPI_Gather| function, we also need 2 
-steps. First of all, data is gathered from slave threads to the master thread or the root thread. Next, the master thread and the root 
-thread execute the \verb|MPI_Gather| operation of complete the communication. Other collective calls such as \verb|MPI_Scan|, 
-\verb|MPI_Reduce|, \verb|MPI_Scatter| \textit{etc} follow the same principle of step-by-step execution.
-
+the performance of the climate models (client). The clients and servers are executed in parallel and communicate asynchronously. In this 
+way, the I/O peaks can be smoothed out as data fluxes are send to server constantly throughout the simulation and the time spent on data 
+writing on the server side can be overlapped completely by calculates on the client side. 
+
+\begin{figure}[ht]
+\includegraphics[scale=0.4]{Charge1.png}
+\includegraphics[scale=0.4]{Charge2.png}
+\caption{On the left, each peak of computing power corresponds to the valley of memory bandwidth which shows that the computing resources 
+are alternating between calculates and I/O. ON the right, both curves are smooth which means that the computing resources have a stable 
+charge of work, either calculates or I/O.}
+\end{figure}
+
+
+XIOS works well with many climate simulation codes. For example, LMDZ\footnote{LMDZ is a general circulation model (or global climate model) 
+developed since the 70s at the "Laboratoire de MÃ©tÃ©orologie Dynamique", which includes various variants for the Earth and other planets 
+(Mars, Titan, Venus, Exoplanets). The 'Z' in LMDZ stands for "zoom" (and the 'LMD' is for  'Laboratoire de MÃ©tÃ©orologie Dynamique"). 
+\url{http://lmdz.lmd.jussieu.fr}}, NENO\footnote{Nucleus for European Modeling of the Ocean alias NEMO is a 
+state-of-the-art modelling framework of ocean related engines. \url{https://www.nemo-ocean.eu}}, ORCHIDEE\footnote{the land surface 
+model of the IPSL (Institut Pierre Simon Laplace) Earth System Model. \url{https://orchidee.ipsl.fr}}, and DYNAMICO\footnote{The DYNAMICO 
+project develops a new dynamical core for LMD-Z, the atmospheric general circulation model (GCM) part of IPSL-CM Earth System Model. 
+\url{http://www.lmd.polytechnique.fr/~dubos/DYNAMICO/}} all use XIOS as the output back end. M\'et\'eoFrance and MetOffice also choose XIOS 
+to manege the I/O for their models.
+
+
+\section{Development of thread-friendly XIOS}
+
+Although XIOS copes well with many models, there is one potential optimization in XIOS which needs to be investigated: making XIOS thread-friendly.
+
+This topic comes along with the configuration of the climate models. Take LMDZ as example, it is designed with the 2-level parallelization scheme. To be more specific, LMDZ uses the domain decomposition method in which each sub-domain is associated with one MPI process. Inside of the sub-domain, the model also uses OpenMP derivatives to accelerate the computation. We can imagine that the sub-domain be divided into sub-sub-domain and is managed by threads. 
+
+\begin{figure}[ht]
+\centering
+\includegraphics[scale=0.5]{domain.pdf}
+\caption{Illustration of the domain decomposition used in LMDZ.}
+\end{figure}
+
+As we know, each sub-domain, or in another word, each MPI process is a XIOS client. The data exchange between client and XIOS servers is handled by MPI communications. In order to write an output field, all threads must gather the data to the master thread who acts as MPI process in order to call MPI routines. There are two disadvantages about this method : first, we have to spend time on gathering information to the master thread which not only increases the memory use, but also implies an OpenMP barrier; second, while the master thread calls MPI routine, other threads are in the idle state thus a waster of computing resources. What we want obtain with the thread-friendly XIOS is that all threads can act like MPI processes. They can call directly the MPI routine thus no waste in memory nor in computing resources as shown in Figure \ref{fig:omp}.
+
+\begin{figure}[ht]
+\centering
+\includegraphics[scale=0.6]{omp.pdf}
+\caption{}
+\label{fig:omp}
+\end{figure}
+
+There are two ways to make XIOS thread-friendly. First of all, change the structure of XIOS which demands a lot of modification is the XIOS library. Knowing that XIOS is about 100 000 lines of code, this method will be very time consuming. What's more, the modification will be local to XIOS. If we want to optimize an other code to be thread-friendly, we have to redo the modifications. The second choice is to add an extra interface to MPI in order to manage the threads. When a thread want to call an MPI routine inside XIOS, it will first pass the interface, in which the communication information will be analyzed before the MPI routine is invoked. With this method, we only need to modify a very small part of XIOS in order to make it work. What is more interesting is that the interface we created can be adjusted to suit other MPI based libraries.
+
+
+In this project, we choose to implement an interface to handle the threads. To do so, we introduce the MPI\_endpoint which is a 
+concept proposed in the last MPI Forums and several papers have already discussed the importance of such idea and have introduced the 
+framework of the MPI\_endpoint \cite{Dinan:2013}\cite{Sridharan:2014}. The concept of an endpoint is shown by Figure \ref{fig:scheme}. In 
+the MPI\_endpoint environment, each OpenMP thread will be associated with a unique rank (global endpoint rank), an endpoint communicator, 
+and a local rank (rank inside the MPI process) which is very similar to the \verb|OMP_thread_num|. The global endpoint rank will replace the 
+role of the classic MPI rank and will be used in MPI communication calls. 
+
+
+\begin{figure}[ht]
+\begin{center}
+\includegraphics[scale=0.4]{scheme.png} 
+\end{center}
+\caption{}
+\label{fig:scheme}
+\end{figure}
+
+%XIOS is a library dedicated to IO management of climate code. It has a client-server pattern in which clients are in charge of computations and servers manage the reading and writing of files. The communication between clients and servers are handled by MPI. However, some of the climate models (\textit{e.g.} LMDZ) nowadays use an hybrid programming policy. Within a shared memory node, OpenMP directives are used to manage message exchanges. In such configuration, XIOS can not take full advantages of the computing resources to maximize the performance. This is because XIOS can only work with MPI processes. Before each call of XIOS routines, threads of one MPI process must gather their information to the master thread who works as an MPI process. After the call, the master thread distributes the updated information among its slave threads. As result, all slave threads have to wait while the master thread calls the XIOS routines. This introduce extra synchronization into the model and leads to not optimized performance. Aware of this situation, we need to develop a new version of XIOS (EP\_XIOS) which can work with threads, or in other words, can consider threads as they were processes. To do so, we introduce the MPI endpoints.  
+
+An other important aspect about the MPI\_endpoint interface is that each endpoints has knowledge of the ranks of other endpoints in the 
+same communicator. This knowledge is necessary because when executing an MPI communication, for example a point-to-point exchange, we need 
+to know not only the ranks of sender/receiver threads, but also the thread number of the sender/receiver threads and the MPI ranks 
+of the sender/receiver processes. This ranking information is implemented inside an map object included in the endpoint communicator 
+class.
+
+
+
+
+%\newpage
+
+%The MPI\_endpoint interface we implemented lies on top of an existing MPI Implementation. It consists of wrappers to all MPI functions 
+%used in XIOS. 
+
+
+In XIOS, we used the ``probe'' technique to search for arrived messages and then perform the receiving action. The principle is 
+that sender process executes the send operation as usual. However, to minimize the time spent on waiting incoming messages, the receiver 
+process calls in the first place the \verb|MPI_Probe| function to check if a message destinate to it has been published. If yes, the 
+process execute in the second place the \verb|MPI_Recv| to receive the message. If not, the receiver process can carry on with other tasks 
+or repeats the \verb|MPI_Probe| and \verb|MPI_Recv| actions if the required message is in immediate need. This technique works well in 
+the current version of XIOS. However, if we introduce threads into this mechanism, problems can occur: The incoming message is labeled by 
+the tag and receiver's MPI rank. Because threads within a process share the MPI rank, and the message probed is always available in the 
+message queue, it can lead to the problem of data race and thus the message can be received by the wrong thread.
+
+
+To solve this problem, we introduce the ``matching-probe'' technique. The idea of the method is that each thread is equipped with a local 
+incoming message queue. Each time a thread calls an MPI function, for example \verb|MPI_Recv|, it calls firstly the \verb|MPI_Mprobe| 
+function to query the MPI incoming message with any tag and from any source. Once a message is probed, the thread gets the handle to the 
+incoming message and this specific message is erased from the MPI message queue. Then, the thread proceed the identification of the message 
+to get the destination thread's local rank and store the message handle to the local queue of the target thread. The thread repeats these 
+steps until the MPI incoming message queue is empty. Then the thread we perform the usual ``probe'' technique to query its local incoming 
+message queue to check if the required message is available. If yes, it performs the \verb|MPI_Recv| operation. With this ``matching-probe'' 
+technique, we can assure that a message is probed only once and is received by the right receiver.
+ 
+
+
+Another issue needs to be clarified with this technique is that: how to identify the receiver's rank? The solution to this question is to 
+use the tag argument. In the MPI environment, a tag is an integer ranging from 0 to $2^{31}$ depending on the Implementation. We can explore 
+the large range property of the tag to store in it information about the source and destination thread ranks. In our endpoint interface, we 
+choose to limit the first 15 bits for the tag used in the classic MPI communication, the next 8 bits to store the sender thread's local 
+rank, and the last 8 bits to store the receiver thread's local rank (\textit{c.f.} Figure \ref{fig:tag}). In this way, with an extra 
+analysis of the tag, we can identify the local ranks of the sender and the receiver in any P2P communication. As results, when a thread 
+probes a message, it knows exactly in which local queue should store the probed message. 
+
+\begin{figure}[ht]
+ \centering
+ \includegraphics[scale=0.4]{tag.png}
+ \caption{}\label{fig:tag}
+\end{figure}
+
+In Figure \ref{fig:tag}, Tag contains the user defined value for a certain communication. MPI\_tag is computed in the endpoint interface 
+with help of the rank map and is used in the MPI calls. 
+
+\begin{figure}[ht]
+\centering
+ \includegraphics[scale = 0.4]{sendrecv.png}
+\caption{This figure shows the classic pattern of a P2P communication with the endpoint interface. Thread/endpoint rank 0 sends a message 
+to thread/endpoint rank 3 with tag=1. The underlying MPI function called by the sender is indeed a send for MPI rank of 1 
+and tag=65537. From the receiver's point of view, the endpoint 3 is actually receving a message from MPI rank 0 with 
+tag=65537.}
+\label{fig:sendrecv}
+\end{figure}
+
+
+
+
+With the rank map, tag extension, and the matching-probe techniques, we are now able to call any P2P communication in the endpoint 
+environment. For the collective communications, we apply a step-by-step execution pattern and no special technique is required. A 
+step-by-step execution pattern consists of 3 steps (not necessarily in this order and not all steps are needed): arrangement of the source 
+data, execution of the MPI function by all master/root threads, distribution or arrangement of the resulting data among threads. 
+
+%The most representative functions of the collective communications are \verb|MPI_Gather| and \verb|MPI_Bcast|.
+
+For example, if we want to perform a broadcast operation, only 2 steps are needed (\textit{c.f.} Figure \ref{fig:bcast}). Firstly, the root 
+thread, along with the master threads of other processes, perform the classic \verb|MPI_Bcast| operation. Secondly, the root thread, and the 
+master threads send data to other threads via local memory transfer. 
+
+\begin{figure}[ht]
+\centering
+\includegraphics[scale=0.3]{bcast.png} 
+\caption{}
+\label{fig:bcast}
+\end{figure}
+
+Figure \ref{fig:allreduce} illustrates how the \verb|MPI_Allreduce| function is proceeded in the endpoint interface. First of all, We 
+perform a intra-process ``allreduce'' operation: source data is reduced from slave threads to the master thread via local memory transfer. 
+Next, alm master threads call the classic \verb|MPI_Allreduce| routine. Finally, all master threads send the updated reduced data to its 
+slaves via local memory transfer. 
+
+\begin{figure}[ht]
+\centering
+\includegraphics[scale=0.3]{allreduce.png} 
+\caption{}
+\label{fig:allreduce}
+\end{figure}
+
+Other MPI routines, such as \verb|MPI_Wait|, \verb|MPI_Intercomm_create| \textit{etc.}, can be found in the technique report of the 
+endpoint interface.
+
+\section{The multi-threaded XIOS and performce results}
+
+The development of endpoint interface for thread-friendly XIOS library took about one year and a half. The main difficulty is the 
+co-existance of MPI processes and OpenMP threads. All MPI classes must be redefined in the endpoint interface along with all the routines. 
+The development is now available on the forge server: \url{http://forge.ipsl.jussieu.fr/ioserver/browser/XIOS/dev/branch_openmp}. One 
+technique report is also available in which one can find more detail about how endpoint works and how the routines are implemented 
+\cite{ep:2018}. We must note that the thread-friendly XIOS library is still in the phase of optimization. It will be released in the 
+future with a stable version.
+
+All the funcionalities of XIOS is reserved in its thread-friendly version. Single threaded code can work successfully with the new 
+version of XIOS. For multi-threaded models, some modifications are needed in order to work with the multi-threaded XIOS library. Detail can 
+be found in our technique report \cite{ep:2018}.
+
+Even though the multi-threaded
 
 \section{Performance of LMDZ using EP\_XIOS}
@@ -114,5 +215,5 @@
 simulation duration settings: 1 day, 5 days, 15 days, and 31 days. 
 
-\begin{figure}[h]
+\begin{figure}[ht]
  \centering
  \includegraphics[scale = 0.6]{LMDZ_perf.png}
@@ -131,5 +232,18 @@
 decrease in time of 25\%. Even the 25\% may seems to be small, it is still a gain in performance with existing computing resources.
 
+\section{Performance of EP\_XIOS}
+
+workfloz\_cmip6 
+light output
+24*8+2
+30s - 52s
+32 days
+histmth with daily output
+
 \section{Perspectives of EP\_XIOS}
 
+
+\bibliographystyle{plain}
+\bibliography{reference}
+
 \end{document}          